ging = read.csv("gambling.csv", header = T)
ging = transform(ging, s = sprintf("s%04d", int(substr(s, 2, 1e6))))

vassign(.(sb, dlong, dwide, timing, tdiff), unpack.tversky(
     "string.sqlite", include.incomplete = F))

sb = ss(sb, char(s) %in% char(ging$s))
dlong = ss(dlong, char(s) %in% char(ging$s))

ming = with(
    dcast(
        na.omit(data.frame(stringsAsFactors = F,
            s = dlong$s,
            str_match(char(dlong$k),
                "^m_(delay|risk)_(ssr|response)\\.(\\d+)$")[,-1],
            v = dlong$v)),
        value.var = "v",
        s + X1 + X3 ~ X2),
    data.frame(
        s,
        type = factor(ucfirst(X1)),
        tn = num(X3),
        ssr = num(ssr),
        equiv = num(response)))
ming = ordf(ming, s, type, tn)

discs = ddply(ming, .(s, type), function(slice)
   {sub = ss(slice, equiv >= ssr)
    data.frame(median = (if (nrow(sub)) median(sub$ssr/sub$equiv) else NA))})
discs = ordf(discs, s, type)
names(discs)[ncol(discs)] = "disc"

sb$ming.good.delay = with(ss(ming, type == "Delay"), tapply(equiv >= ssr, droplevels(s), sum))
sb$ming.good.risk = with(ss(ming, type == "Risk"), tapply(equiv >= ssr, droplevels(s), sum))

bad.s = unique(c(
    qw(s0003, s0018, s0019, s0020), # From subject-notes.txt
    row.names(ss(sb, ming.good.delay < 5 | ming.good.risk < 5))))
good.s = setdiff(row.names(sb), bad.s)

sb$n.gambles = unname(with(ging, tapply(choice == "Gamble", s, sum)))
sb$disc.delay = ss(discs, type == "Delay")$disc
sb$disc.risk = ss(discs, type == "Risk")$disc
